
#import <Foundation/NSObject.h>
#import <Foundation/NSGeometry.h>

#define DRAW_NONE		0
#define DRAW_LINE		1
#define DRAW_CURVE		2
#define DRAW_BEZIER		4
#define DRAW_ALL		DRAW_LINE | DRAW_CURVE | DRAW_BEZIER

@class MiscUserPath, BezierORShape;

typedef enum {
	UnitParametrisationType,
	ChordalParametrisationType,
	ZentripedalParametrisationType,
	FoleyParametrisationType,
} ParametrisationType;

typedef enum {
	SecondDerivateType,
	FirstDerivateType,
	QuadraticType,
} EndPointType;
	
@interface Spline : NSObject 
{
@private
	MiscUserPath *linePath, *splinePath, *bezierControlPath;
	int numberOfPoints;
	NSPoint *points,*bezierPoints;
	int maxNumberOfPoints;
	ParametrisationType parametrisation;
	EndPointType endPointA,endPointB;
}

- (void)empty;
- (void)drawWithPoint:(NSPoint)aPoint :(int)flags;
- (void)drawWithFlags:(int)flags;
- (void)addPoint:(NSPoint)aPoint;
- (int)hitWithPoint:(NSPoint)aPoint;
- (void)changePointNr:(int)nr to:(NSPoint)aPoint;
- (ParametrisationType)parametrisationType;
- (void)setParametrisationType:(ParametrisationType)aParametrisationType;
- (EndPointType)endPointAType;
- (void)setEndPointAType:(EndPointType)aEndPointType;
- (EndPointType)endPointAType;
- (void)setEndPointBType:(EndPointType)aEndPointType;
- (NSRect)splineBounds;
- (void)drawSpecial;
- (BezierORShape *)rot3DShape;

@end


